#ifndef __ABSTRACTQUEUE_H
#define __ABSTRACTQUEUE_H

template< typename T >
class AbstractQueue
{
public:
  virtual ~AbstractQueue(){}
  virtual const char* getName() = 0;
  virtual void enqueue(T element) = 0;
  virtual bool dequeue(T& element) = 0;   // returns true on success
  virtual bool peekFront(T& element) = 0; // returns true if queue is non-empty
  virtual bool peekBack(T& element) = 0;  // return true if queue is non-empty
protected:
  virtual bool steal(T& element) = 0;     //just like dequeue, except the data is pulled from the back of the queue
                                          // it is a protected member because it can only be accessed by another task queue 
};

#endif // __ABSTRACTQUEUE_H
