#ifndef __ATOMIC_H
#define __ATOMIC_H

static inline int fetchAndAdd(volatile int & var, int addend);


/* if(a==b) {a=c; c=a} */
static inline bool compareAndSwap(volatile int & a, int b, int c);


#if defined(__sparc) || defined(__sparc__) || defined(sparc)
#include "AtomicSparc.h"
#elif defined(__tune_i686__) || defined(__x86_64__) || defined(__x86_64) || defined(__amd64)

static inline long long int fetchAndAdd(volatile long long int & var, long long int addend);
static inline unsigned long long int fetchAndAdd(volatile unsigned long long int & var, long long int addend);

static inline bool compareAndSwap(volatile long long int & a, long long int b, long long int c);
static inline bool compareAndSwap(volatile unsigned long long int & a, unsigned long long int b, unsigned long long int c);
#include "AtomicX86.h"

#else
#error "Architecture not supported"
#endif

#endif // __ATOMIC_H
