
#ifndef TASKMAN_TIMERS_H
#define TASKMAN_TIMERS_H

#if defined(__sparc)

// gethrtime already defined
#include <sys/time.h>

inline double get_time_delta_s(hrtime_t t1, hrtime_t t2){
  return ((double)(t1-t2))/1.0e9;
}

/*
inline double get_time_delta_ms(hrtime_t t1, hrtime_t t2){
  return ((double)(t1-t2))/1.0e6;
}

inline double get_time_delta_us(hrtime_t t1, hrtime_t t2){
  return ((double)(t1-t2))/1.0e3;
}


inline hrtime_t get_time_delta_ns(hrtime_t t1, hrtime_t t2){
  return (t1-t2);
}
*/

#elif defined(__i386) || defined(__tune_i686__) || defined(__x86_64__) || defined(__x86_64) || defined(__amd64)
 
#include "TaskMan.h"

typedef long long int hrtime_t;

extern "C" {
  __inline__ hrtime_t rdtsc() {
    unsigned long int lo, hi;
    __asm__ __volatile__ ("rdtsc" : "=a" (lo), "=d" (hi));
    return (hrtime_t)hi << 32 | lo;
  }
}

inline hrtime_t gethrtime() {
  return rdtsc();
}

inline hrtime_t get_hrtime_delta( float time_ns ) {
  return static_cast<hrtime_t>((g_cpu_mhz/1000.0)*time_ns);
}

inline double get_time_delta_s(hrtime_t t1, hrtime_t t2){
  return ((double)(t1-t2))/(g_cpu_mhz*1.0e6);
}

/*
inline double get_time_delta_ms(hrtime_t t1, hrtime_t t2){
  return (t1-t2)/g_cpu_khz;
}

inline double get_time_delta_us(hrtime_t t1, hrtime_t t2){
  return (t1-t2)/g_cpu_mhz;
}


inline unsigned long long int get_time_delta_ns(hrtime_t t1, hrtime_t t2){
  return (t1-t2)/static_cast<unsigned long long int> ((static_cast<float>(g_cpu_khz)/1000000.0));
}
*/

#endif

#endif
