#ifndef __VECTOR_H
#define __VECTOR_H

template< typename T >
class Vector
{
public:
  Vector(){
    m_data_array = new T[16]; //default initial size
    m_capacity = 16;
    m_size = 0;
  }

  Vector(int initial_capacity){
    m_data_array = new T[initial_capacity];
    m_capacity = initial_capacity;
    m_size = 0;
  }

  ~Vector(){
    delete[] m_data_array;
  }

  /* returns the index that the data was inserted at */
  int pushBack(T data) {
    if(m_size >= m_capacity){
      mGrow();
    }
    m_data_array[m_size] = data;
    m_size++;
    return m_size-1;
  }

  const T& operator[](int index) const { return m_data_array[index]; }
  //T& operator[](int index) const { return m_data_array[index]; }

private:
  void mGrow() {
    T* temp;
    m_capacity *= 2;
    temp = new T[m_capacity];
    for(int i=0; i<m_size; i++){
      temp[i] = m_data_array[i];
    }
    delete[] m_data_array;
    m_data_array = temp;
  }

private:
  T* m_data_array;
  int m_capacity;
  int m_size;
};

#endif // __VECTOR_H
