
#include <pthread.h>
#include <stdlib.h>
#include "CarbonQueue.h"

class AbstractResult;

int num_threads = 0;
int num_threads_at_barrier = 0;

void* TestBody( void* args )
{
  num_threads_at_barrier++;
  while(num_threads_at_barrier != num_threads) {}
  
  CarbonQueue<AbstractResult*> q;
  AbstractResult* res;

  q.enqueue(NULL);
  q.dequeue(res);
}

int main(int argc, char* argv[])
{
  pthread_t* threads;

  assert(argc == 2);
  
  num_threads = atoi(argv[1]);

  threads = new pthread_t[num_threads-1];

  for(int i=1;i<num_threads;i++){
    fprintf(stderr, "Creating a new thread\n");
    pthread_create(&threads[i-1],NULL,TestBody,NULL);
  }

  RUBY_MAGIC_CALL(0x40000); // start ruby now
  CarbonQueue<AbstractResult*>::init(num_threads-1);

  TestBody( NULL );

  for(int i=1;i<num_threads;i++){
    pthread_join(threads[i-1], NULL);
  }

  return EXIT_SUCCESS;

}
