
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <tbb/tick_count.h>

long fib(int n)
{
     if (n < 2)
	  return (n);
     else {
         // execute serially
         long x, y;
         x = fib(n-1);
         y = fib(n-2);
         return x+y;
     } 
}

int main(int argc, char *argv[])
{
  long n;
  long num_procs;
  tbb::tick_count end_time, start_time;
  long result;

     if (argc != 3) {
	  fprintf(stderr, "Usage: fib <n> <num_procs>\n");
	  exit(EXIT_FAILURE);
     }
     n = atoi(argv[1]);
     num_procs = atoi(argv[2]);

     start_time = tbb::tick_count::now();

     result = fib(n);

     end_time = tbb::tick_count::now();

     std::cout << "result = " << result << std::endl;
     std::cout << "time = " << (end_time - start_time).seconds() << "s" << std::endl;
     
     return 0;
}
