
#include <stdlib.h>
#include <stdio.h>

#include <TaskMan.h>
#include <Timers.h>

long fib(int n)
{
     if (n < 2)
	  return (n);
     else {
       if(n < 16){
         // execute serially
         long x, y;
         x = fib(n-1);
         y = fib(n-2);
         return x+y;
       } else {
          result<long> x, y;
	  x = task (fib, n - 1);
	  y = task (fib, n - 2);
	  return (*x + *y);
       }
     }
}

int main(int argc, char *argv[])
{
  long n;
  long dummy;
  long num_procs;
  hrtime_t end_time, start_time;
  result<long> result;

     if (argc != 3) {
	  fprintf(stderr, "Usage: fib <n> <num_procs>\n");
	  exit(EXIT_FAILURE);
     }
     n = atoi(argv[1]);
     num_procs = atoi(argv[2]);
     
     taskman_init( num_procs - 1 );

     start_time = gethrtime();

     result = task(fib, n);
     dummy = *result;

     end_time = gethrtime();

     std::cout << "result = " << *result << std::endl;
     std::cout << "time = " << get_time_delta_s(end_time, start_time) << "s" << std::endl;

     taskman_shutdown();
     
     return 0;
}
