
#include <iostream>
#include <pthread.h>

#include <AbstractQueue.h>
#include <XactionQueue.h>
#include <FineGrainedLockQueue.h>

using namespace std;

void* ThreadBody(void* args)
{
  AbstractQueue<int>* q;
  //int thread_id = static_cast<int> (args);

  int num_dequeues = 0;
  int val;  

  //q = new XactionQueue<int>();
  q = new FineGrainedLockQueue<int>();

  for(int i=0;i<1000000;i++){
    q->enqueue(i);
    q->enqueue(i+1000000);
    if(q->dequeue(val)) num_dequeues++;
  }

  while(q->dequeue(val)){
      num_dequeues++;
  }
  
  pthread_exit(reinterpret_cast<void*> (num_dequeues));
}

int main(int argc, char* argv[])
{
  assert(argc == 2); 

  int num_threads = atoi(argv[1]);
  pthread_t* threads = new pthread_t[num_threads];
  int* results = new int[num_threads];
  int total_results = 0;

  pthread_mutexattr_t attr;
  pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE);
  //  pthread_mutex_init(&XactionQueue<int>::m_xaction_mutex, &attr);

  for(int i=0;i<num_threads;i++){
    pthread_create(&threads[i], NULL, &ThreadBody, reinterpret_cast<void*> (i) );
  } 

  for(int i=0;i<num_threads;i++){
    pthread_join(threads[i], reinterpret_cast<void**> (&results[i]) );
    cout << "thread " << i << ": " << results[i] << " dequeues\n";
  } 

  for(int i=0;i<num_threads;i++){
    total_results += results[i];
  } 
  cout << "total: " << total_results << " dequeues\n";

}
