#include <TaskMan.h>
#include <iostream>

typedef unsigned long long fact_t;

fact_t simple_factorial( fact_t n ){
  if( n <= 1 ) return 1;
  else return n * (simple_factorial(n-1));
}


fact_t factorial( fact_t n ){
  if( n <= 1 ) return 1;
  else{
    result< fact_t > res = task( factorial, n-1 );

    // just some paranoid sanity checking.
    {
      fact_t tester = simple_factorial( n-1 );
      fact_t real = *res;
      assert( real == tester );
    }

    return (*res) * n;
  }
}

int add2( int n1, int n2 ){

  return n1 + n2;

}

float mult3( float f1, float f2, float f3 ){
  return f1 * f2 * f3;
}

float mult4( float f1, float f2, int i1, int i2 ){
  return f1 * f2 * float ( i1 + i2 );
}

int main(){

  fact_t x = 20;

  taskman_init(3);

  result< float > mult_r = task ( mult3, 12.0, 1.0, 14.40 );
  result< int > add_r = task ( add2, 49, 7 );
  result< fact_t > r = task( factorial, x );
  result< float > mult4_r = task( mult4, 12.0, 14.0, 32, 64 );

  std::cout << "Factorial result is " << *r << std::endl;
  std::cout << "Add result is " << *add_r << std::endl;
  std::cout << "Mult result is " << *mult_r << std::endl;
  std::cout << "Mult4 result is " << *mult4_r << std::endl;

  return 0;

}
